DEFINT A-Z
DECLARE FUNCTION Exist% (FileName$)
DECLARE FUNCTION QPValL& (Number$)

DECLARE FUNCTION CountDirLst% (FileName$)
DECLARE FUNCTION GetDirFile$ (FileName$, DirNumber AS INTEGER)
DECLARE FUNCTION StripZero$ (FileName$)
DECLARE SUB GetParm (ConfNum&, InFile$, ConfigFile$)

TYPE CNAMESRECORD
    ConfName    AS STRING * 14
    PublicConf  AS STRING * 1
    AutoRejoin  AS STRING * 1
    ViewMembers AS STRING * 1
    PrivUplds   AS STRING * 1
    PrivMsgs    AS STRING * 1
    EchoMail    AS STRING * 1
    ReqSecLevel AS INTEGER
    AddSec      AS INTEGER
    AddTime     AS INTEGER
    MsgBlocks   AS STRING * 1
    MsgFile     AS STRING * 32
    UserMenu    AS STRING * 32
    SysopMenu   AS STRING * 32
    NewsFile    AS STRING * 32
    PubUpldSort AS STRING * 1
    UpldDir     AS STRING * 29
    PubUpldLoc  AS STRING * 26
    PrvUpldSort AS STRING * 1
    PrivDir     AS STRING * 29
    PrvUpldLoc  AS STRING * 26
    DrsMenu     AS STRING * 29
    DrsFile     AS STRING * 33
    BltMenu     AS STRING * 29
    BltNameLoc  AS STRING * 33
    ScrMenu     AS STRING * 29
    ScrNameLoc  AS STRING * 33
    DirMenu     AS STRING * 29
    DirNameLoc  AS STRING * 33
    PthNameLoc  AS STRING * 33
END TYPE
DIM SHARED CNAMES AS CNAMESRECORD

TYPE DirFileLST
    FilePath AS STRING * 30
    SubDir AS STRING * 30
    FileDesc AS STRING * 35
    SORT AS STRING * 1
END TYPE
DIM SHARED PCBDIR AS DirFileLST

CALL GetParm(ConfNum&, InFile$, ConfigFile$)
IF NOT Exist%(InFile$) THEN END

FilNum = FREEFILE
OPEN InFile$ FOR BINARY ACCESS READ SHARED AS #FilNum LEN = 2
    RecLength$ = SPACE$(2)
    GET #FilNum, , RecLength$
    RecLength = CVI(RecLength$)
   
    SEEK #FilNum, ((ConfNum&) * RecLength + 1) + 2
    GET #FilNum, , CNAMES
    PCBDirList$ = StripZero$(CNAMES.DirNameLoc)
    PCBUpLdDir$ = StripZero$(CNAMES.UpldDir)
CLOSE #FilNum

ConfigNum = FREEFILE
OPEN ConfigFile$ FOR OUTPUT AS #ConfigNum
    PRINT #ConfigNum, StripZero$(CNAMES.DirMenu)

    DirCount% = CountDirLst%(PCBDirList$)
    IF LEN(PCBUpLdDir$) > 0 THEN
        PRINT #ConfigNum, LTRIM$(STR$(DirCount% + 1))
    ELSE
        PRINT #ConfigNum, LTRIM$(STR$(DirCount%))
    END IF

    FOR Lp% = 1 TO DirCount%
        Temp$ = GetDirFile$(PCBDirList$, Lp%)
        PRINT #ConfigNum, Temp$
    NEXT
    PRINT #ConfigNum, PCBUpLdDir$
CLOSE #ConfigNum

FUNCTION CountDirLst% (FileName$) STATIC
    
    IF NOT Exist%(FileName$) THEN END
    FileNumber = FREEFILE
    OPEN FileName$ FOR RANDOM ACCESS READ SHARED AS #FileNumber LEN = 96
   
    DirListCount = LOF(FileNumber) \ 96
    CountDirLst% = DirListCount
    CLOSE #FileNumber
    
END FUNCTION

FUNCTION GetDirFile$ (FileName$, DirNumber AS INTEGER) STATIC
    
    IF NOT Exist%(FileName$) THEN END
    FileNumber = FREEFILE
    OPEN FileName$ FOR RANDOM ACCESS READ SHARED AS #FileNumber LEN = 96
    
    GET #FileNumber, DirNumber, PCBDIR
    GetDirFile$ = LTRIM$(PCBDIR.FilePath)
    CLOSE #FileNumber

END FUNCTION

SUB GetParm (ConfNum&, InFile$, ConfigFile$) STATIC
   
    IF LEN(COMMAND$) THEN
        Param = 1
        P = 1
        DO
            PC = INSTR(P, COMMAND$, " ")
            IF PC = 0 THEN PC = INSTR(P, COMMAND$, " ")
            IF PC = 0 THEN PC = LEN(COMMAND$) + 1
            Temp$ = UCASE$(LTRIM$(RTRIM$(MID$(COMMAND$, P, PC - P))))
           
            SELECT CASE Param
                CASE 1: ConfNum& = QPValL&(Temp$)
                CASE 2: InFile$ = Temp$
                CASE 3: ConfigFile$ = Temp$
            END SELECT
           
            Param = Param + 1
            P = PC + 1
        LOOP UNTIL PC >= LEN(COMMAND$)
    END IF
   
END SUB

FUNCTION StripZero$ (FileName$) STATIC

    TabPos = INSTR(FileName$, CHR$(0))
    DO WHILE TabPos > 0
        FileName$ = LEFT$(FileName$, TabPos - 1) + MID$(FileName$, TabPos + 1)
        TabPos = INSTR(TabPos, FileName$, CHR$(0))
    LOOP
    StripZero$ = RTRIM$(FileName$)

END FUNCTION
