DEFINT A-Z
DECLARE FUNCTION QPLeft$ (Work$, NumSpace%)
DECLARE FUNCTION QPTrim$ (Work$)
DECLARE FUNCTION QPLen% (Work$)
DECLARE FUNCTION Exist% (FileName$)
DECLARE FUNCTION QPValL& (Number$)

DECLARE FUNCTION ParsePath$ (FSpec$, Path$)
DECLARE FUNCTION CountDirLst% (FileName$)
DECLARE FUNCTION GetDirFile$ (FileName$, DirNumber AS INTEGER)
DECLARE FUNCTION StripZero$ (FileName$)
DECLARE SUB GetParm (ConfNum&, InFile$, ConfigFile$)

TYPE CNAMESRECORD
    ConfName    AS STRING * 14
    PublicConf  AS STRING * 1
    AutoRejoin  AS STRING * 1
    ViewMembers AS STRING * 1
    PrivUplds   AS STRING * 1
    PrivMsgs    AS STRING * 1
    EchoMail    AS STRING * 1
    ReqSecLevel AS INTEGER
    AddSec      AS INTEGER
    AddTime     AS INTEGER
    MsgBlocks   AS STRING * 1
    MsgFile     AS STRING * 32
    UserMenu    AS STRING * 32
    SysopMenu   AS STRING * 32
    NewsFile    AS STRING * 32
    PubUpldSort AS STRING * 1
    UpldDir     AS STRING * 29
    PubUpldLoc  AS STRING * 26
    PrvUpldSort AS STRING * 1
    PrivDir     AS STRING * 29
    PrvUpldLoc  AS STRING * 26
    DrsMenu     AS STRING * 29
    DrsFile     AS STRING * 33
    BltMenu     AS STRING * 29
    BltNameLoc  AS STRING * 33
    ScrMenu     AS STRING * 29
    ScrNameLoc  AS STRING * 33
    DirMenu     AS STRING * 29
    DirNameLoc  AS STRING * 33
    PthNameLoc  AS STRING * 33
END TYPE
DIM SHARED CNAMES AS CNAMESRECORD

TYPE DirFileLST
    FilePath AS STRING * 30
    SubDir AS STRING * 30
    FileDesc AS STRING * 35
    SORT AS STRING * 1
END TYPE
DIM SHARED PCBDIR AS DirFileLST

CALL GetParm(ConfNum&, InFile$, ConfigFile$)
IF NOT Exist%(InFile$) THEN END

FilNum = FREEFILE
OPEN InFile$ FOR BINARY ACCESS READ SHARED AS #FilNum LEN = 2
    RecLength$ = SPACE$(2)
    GET #FilNum, , RecLength$
    RecLength = CVI(RecLength$)
   
    SEEK #FilNum, ((ConfNum&) * RecLength + 1) + 2
    GET #FilNum, , CNAMES
    DirList$ = StripZero$(CNAMES.DirNameLoc)
    DlPathList$ = StripZero$(CNAMES.PthNameLoc)

    UpldDir$ = ParsePath$(StripZero$(CNAMES.UpldDir), UpldPath$)
CLOSE #FilNum

ConfigNum = FREEFILE
OPEN ConfigFile$ FOR APPEND AS #ConfigNum
    DirCount% = CountDirLst%(DirList$)
    FOR Lp% = 1 TO DirCount%
        FileName$ = ParsePath$(GetDirFile$(DirList$, Lp%), Path$)
        PRINT #ConfigNum, Path$ + "," + FileName$ + ",0," + "NOTIME"
    NEXT Lp%
    PRINT #ConfigNum, UpldPath$ + "," + UpldDir$ + ",0," + "NOTIME"
CLOSE #ConfigNum

PathList = FREEFILE
OPEN DlPathList$ FOR APPEND AS #PathList
    Dummy$ = ParsePath$(GetDirFile$(DirList$, 1), FirstPath$)
    PRINT #PathList, FirstPath$
    FOR Lp% = 2 TO DirCount%
        Dummy$ = ParsePath$(GetDirFile$(DirList$, Lp%), Path$)
        IF Path$ <> FirstPath$ THEN PRINT #PathList, Path$
    NEXT Lp%
    IF UpldPath$ <> FirstPath$ THEN PRINT #PathList, UpldPath$
CLOSE #PathList

FUNCTION CountDirLst% (FileName$) STATIC
    
    IF NOT Exist%(FileName$) THEN END
    FileNumber = FREEFILE
    OPEN FileName$ FOR RANDOM ACCESS READ SHARED AS #FileNumber LEN = 96
   
    DirListCount = LOF(FileNumber) \ 96
    CountDirLst% = DirListCount
    CLOSE #FileNumber
    
END FUNCTION

FUNCTION GetDirFile$ (FileName$, DirNumber AS INTEGER) STATIC
    
    IF NOT Exist%(FileName$) THEN END
    FileNumber = FREEFILE
    OPEN FileName$ FOR RANDOM ACCESS READ SHARED AS #FileNumber LEN = 96
    
    GET #FileNumber, DirNumber, PCBDIR
    GetDirFile$ = QPTrim$(PCBDIR.FilePath)
    CLOSE #FileNumber

END FUNCTION

SUB GetParm (ConfNum&, InFile$, ConfigFile$) STATIC
   
    IF QPLen%(COMMAND$) THEN
        Param = 1
        P = 1
        DO
            PC = INSTR(P, COMMAND$, " ")
            IF PC = 0 THEN PC = INSTR(P, COMMAND$, " ")
            IF PC = 0 THEN PC = QPLen%(COMMAND$) + 1
            Temp$ = UCASE$(QPTrim$(MID$(COMMAND$, P, PC - P)))
           
            SELECT CASE Param
                CASE 1: ConfNum& = QPValL&(Temp$)
                CASE 2: InFile$ = Temp$
                CASE 3: ConfigFile$ = Temp$
            END SELECT
           
            Param = Param + 1
            P = PC + 1
        LOOP UNTIL PC >= QPLen%(COMMAND$)
    END IF
   
END SUB

FUNCTION ParsePath$ (FSpec$, Path$) STATIC

    IF QPLen%(FSpec$) THEN
        Lp = INSTR(FSpec$, "\")
        B$ = MID$(FSpec$, Lp + 1)

        DO WHILE INSTR(B$, "\")
            B$ = MID$(B$, INSTR(B$, "\") + 1)
        LOOP
      
        ParsePath$ = QPTrim$(B$)
        Path$ = UCASE$(QPLeft$(QPTrim$(FSpec$), QPLen%(QPTrim$(FSpec$)) - QPLen%(QPTrim$(B$))))
    ELSE
        ParsePath$ = QPTrim$(FSpec$)
    END IF

END FUNCTION

FUNCTION StripZero$ (FileName$) STATIC

    TabPos = INSTR(FileName$, CHR$(0))
    DO WHILE TabPos > 0
        FileName$ = LEFT$(FileName$, TabPos - 1) + MID$(FileName$, TabPos + 1)
        TabPos = INSTR(TabPos, FileName$, CHR$(0))
    LOOP
    StripZero$ = QPTrim$(FileName$)

END FUNCTION

